Description

Abstraction

"Edit this section" in Wiki with the Markdown syntax does not extract ATX headings correctly.

ATX headings:

# Headline

## Headline

 The current trunk(rev.22841) and v5.0.2 extracts it by the regexp '#+.+', but this would not be sufficient.

Especially, since it does not consider the following condition, it mishandles ticket references such as "#11111" or "##11111".

The opening sequence of # characters must be followed by a space or by the end of line.

 I explain the details in "How to reproduce".

Note: the regexps about extracting ATX headings:

https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper

.rb#L45

@text.split(/(^(?:\S+\r?\n\r?(?:\=+|\-+)|#+.+|(?:~~~|```).*)\s*$)/).each do |part|

 https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper

.rb#L55-L56

          elsif part =~ /\A(#+).+/

            level = $1.size

 

How to reproduce

Prepare Wiki with the Markdown syntax as follows.

# Wiki

## Section A

A

##1 : this is a ticket reference.

AA

## Section B

B

2025-04-03 1/3

https://github.github.com/gfm/#atx-heading
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L45
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L45
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L55-L56
https://github.com/redmine/redmine/blob/c0af36b12da1d053d87735c174e7c79e97254e75/lib/redmine/wiki_formatting/section_helper.rb#L55-L56


  how-to-reproduce-sample1-entire.png 

We can click each section's "Edit this section" button (surrounded by red rectangles in the image above).

However, we can't edit each section correctly since the ticket reference "##1" is wrongly detected as a level 2 section.

When clicking the button of "Section A":

(URI: "Wiki/edit?section=2")

 how-to-reproduce-sample1-edit-section2.png 

When clicking the button of "Section B":

(URI: "Wiki/edit?section=3")

 how-to-reproduce-sample1-edit-section3.png 

The expected result when clicking the button of "Section A":

A

##1 : this is a ticket reference.

AA

 The expected result when clicking the button of "Section B":

B

 

Environment

$ RAILS_ENV=development bin/about

Environment:

  Redmine version                5.1.2.devel

  Ruby version                   3.2.2-p53 (2023-03-30) [x86_64-linux]

  Rails version                  7.1.2

  Environment                    development

  Database adapter               SQLite

  Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

  Mailer delivery                smtp

Redmine settings:

  Redmine theme                  Default

SCM:

  Subversion                     1.13.0

  Git                            2.25.1

  Filesystem                     

Redmine plugins:

  no plugin installed

<!-- MarkdownTOC -->   

<!-- /MarkdownTOC -->

Related issues:

Is duplicate of Redmine - Defect #40716: "Edit this section" on Wiki pages mi... Closed

History

#1 - 2024-05-22 04:44 - daijiro fukuda

Sorry, I accidentally submitted this in the middle.

Could you please discard this ticket as I recreate this?

#2 - 2024-05-22 05:27 - daijiro fukuda

I recreate the issue:

Defect #40716: "Edit this section" on Wiki pages misinterprets issue links with double hash (##nnn) as ATX headings

Sorry for the trouble. please discard this ticket.

#3 - 2024-05-22 08:37 - Marius BĂLTEANU
https://www.redmine.org/issues/40716


- Status changed from New to Closed

- Resolution set to Duplicate

#4 - 2024-05-22 08:38 - Marius BĂLTEANU

- Is duplicate of Defect #40716: "Edit this section" on Wiki pages misinterprets issue links with double hash (##nnn) as ATX headings added
